import { Action, Certificate } from "./Trello";
import { Apps } from "./Kintone";
import { SettingGuardian } from "./Setting";
export declare class Trekin {
    private kintoneApps;
    private trelloCert;
    private worker;
    guardian: SettingGuardian;
    private readonly defaultSettingPath;
    constructor(kintoneApps: Apps, trelloCert: Certificate);
    readSetting(filePath?: string | undefined): Promise<void>;
    operation(trelloAction: Action): Promise<string | {
        app: string;
        id?: string;
        record: {
            [key: string]: {
                value: string | string[] | Array<{
                    id: string;
                }> | undefined;
            };
        };
    } | {
        app: string;
        comment: {
            text: string;
        };
    } | {
        [key: string]: {
            value: string;
        };
    }>;
    postOperation(trelloAction: Action): Promise<string | (string | {
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: Date;
            };
        };
    } | {
        url: any;
        status: any;
        statusText: any;
        text: any;
    } | Promise<{
        url: any;
        status: any;
        statusText: any;
        text: any;
    }> | undefined)[]>;
}
