"use strict";
/* eslint-disable no-loop-func */
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var rest_api_client_1 = require("@kintone/rest-api-client");
var Trekin_1 = require("../Trekin");
var fs = __importStar(require("fs"));
var Kintone_1 = require("../Kintone");
jest.mock("@kintone/rest-api-client");
var KintoneMock = rest_api_client_1.KintoneRestAPIClient;
var runOperationKintone = function (inputFilePath, mockOverrides) {
    if (mockOverrides === void 0) { mockOverrides = undefined; }
    return __awaiter(void 0, void 0, void 0, function () {
        var t, action, _a, _b;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    KintoneMock.mockImplementation(function () {
                        return {
                            record: __assign({ addRecord: function () {
                                    return Promise.resolve({});
                                }, getRecords: function () {
                                    return Promise.resolve({
                                        records: [{ $id: { value: "aaa" } }, { $id: { value: "bbb" } }],
                                    });
                                }, updateRecord: function () {
                                    return Promise.resolve({});
                                }, addRecordComment: function () {
                                    return Promise.resolve({});
                                } }, mockOverrides),
                        };
                    });
                    t = new Trekin_1.Trekin({
                        baseUrl: "",
                        cards: { id: "", token: "" },
                        defaultKintoneUserCode: "",
                        labels: { id: "", token: "" },
                        lists: { id: "", token: "" },
                        members: { id: "", token: "" },
                    }, { apiKey: "", apiToken: "" });
                    _b = (_a = JSON).parse;
                    return [4 /*yield*/, fs.readFileSync(inputFilePath, "utf8")];
                case 1:
                    action = _b.apply(_a, [_c.sent()]).body.action;
                    return [4 /*yield*/, t.readSetting("./src/__tests__/trekin_settings/.trekinrc.json5")];
                case 2:
                    _c.sent();
                    return [2 /*return*/, t.operation(action)];
            }
        });
    });
};
describe("createCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "カードを追加できる",
            input: "./src/__tests__/trello_events/createCard_1.json",
            expected: {
                app: "",
                record: (_a = {},
                    _a[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                    _a[Kintone_1.CardApp.id] = { value: "5f1590bb8a1a602edd449930" },
                    _a[Kintone_1.CardApp.link] = { value: "https://trello.com/c/ceDVYykj" },
                    _a[Kintone_1.CardApp.idList] = { value: "5f1e8b1ed6438e403c6f18fe" },
                    _a),
            },
        },
        {
            name: "listがjsonにない場合でも追加できる",
            input: "./src/__tests__/trello_events/createCard_2.json",
            expected: {
                app: "",
                record: (_b = {},
                    _b[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                    _b[Kintone_1.CardApp.id] = { value: "5f1590bb8a1a602edd449930" },
                    _b[Kintone_1.CardApp.link] = { value: "https://trello.com/c/ceDVYykj" },
                    _b),
            },
        },
    ];
    var _loop_1 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_1 = testcases; _i < testcases_1.length; _i++) {
        var _c = testcases_1[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_1(name, input, expected);
    }
});
describe("updateCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "oldにキーがある場合recordにもキーが含まれる",
            input: "./src/__tests__/trello_events/updateCard_idList_1.json",
            expected: (_a = {},
                _a[Kintone_1.CardApp.id] = { value: "newId" },
                _a[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                _a[Kintone_1.CardApp.idList] = { value: "newIdList" },
                _a),
        },
        {
            name: "oldにキーがない場合recordにキーは含まれない",
            input: "./src/__tests__/trello_events/updateCard_idList_2.json",
            expected: (_b = {},
                _b[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                _b[Kintone_1.CardApp.idList] = { value: "newIdList" },
                _b),
        },
    ];
    var _loop_2 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_2 = testcases; _i < testcases_2.length; _i++) {
        var _c = testcases_2[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_2(name, input, expected);
    }
});
describe("createListのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "リストを追加できる",
            input: "./src/__tests__/trello_events/createList_1.json",
            expected: {
                app: "",
                record: (_a = {},
                    _a[Kintone_1.ListApp.name] = { value: "新しいリスト" },
                    _a[Kintone_1.ListApp.id] = { value: "5f1e40c92cfacb6dc5d4bbe5" },
                    _a),
            },
        },
    ];
    var _loop_3 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_3 = testcases; _i < testcases_3.length; _i++) {
        var _b = testcases_3[_i], name = _b.name, input = _b.input, expected = _b.expected;
        _loop_3(name, input, expected);
    }
});
describe("updateListのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "リストを更新できる",
            input: "./src/__tests__/trello_events/updateList_1.json",
            expected: (_a = {},
                _a[Kintone_1.ListApp.name] = { value: "テスト2" },
                _a),
        },
        {
            name: "リストをアーカイブできる",
            input: "./src/__tests__/trello_events/updateList_closed_1.json",
            expected: (_b = {},
                _b[Kintone_1.ListApp.closed] = { value: true },
                _b),
        },
    ];
    var _loop_4 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_4 = testcases; _i < testcases_4.length; _i++) {
        var _c = testcases_4[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_4(name, input, expected);
    }
});
describe("createLabelのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "ラベルを追加できる",
            input: "./src/__tests__/trello_events/createLabel_1.json",
            expected: {
                app: "",
                record: (_a = {},
                    _a[Kintone_1.LabelApp.name] = { value: "黒いラベルだよ！" },
                    _a[Kintone_1.LabelApp.id] = { value: "5f1e6180d9aed686cc5a1ca5" },
                    _a[Kintone_1.LabelApp.color] = { value: "black" },
                    _a),
            },
        },
    ];
    var _loop_5 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_5 = testcases; _i < testcases_5.length; _i++) {
        var _b = testcases_5[_i], name = _b.name, input = _b.input, expected = _b.expected;
        _loop_5(name, input, expected);
    }
});
describe("updateLabelのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "ラベルを更新できる",
            input: "./src/__tests__/trello_events/updateLabel_1.json",
            expected: {
                app: "",
                id: "5f02821bf1bb5752f63a5ae5",
                record: (_a = {},
                    _a[Kintone_1.LabelApp.name] = { value: "新しいラベルだ！" },
                    _a[Kintone_1.LabelApp.color] = { value: "yellow" },
                    _a),
            },
            mock: {
                getRecords: function () {
                    return Promise.resolve({
                        records: [{ $id: { value: "5f02821bf1bb5752f63a5ae5" } }],
                    });
                },
            },
        },
        {
            name: "ラベルがアプリ上に存在しない場合、作成できる",
            input: "./src/__tests__/trello_events/updateLabel_1.json",
            expected: {
                app: "",
                record: (_b = {},
                    _b[Kintone_1.LabelApp.name] = { value: "新しいラベルだ！" },
                    _b[Kintone_1.LabelApp.id] = { value: "5f02821bf1bb5752f63a5ae5" },
                    _b[Kintone_1.LabelApp.color] = { value: "yellow" },
                    _b),
            },
            mock: {
                getRecords: function () {
                    return Promise.resolve({
                        records: [],
                    });
                },
            },
        },
    ];
    var _loop_6 = function (name, input, expected, mock) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_6 = testcases; _i < testcases_6.length; _i++) {
        var _c = testcases_6[_i], name = _c.name, input = _c.input, expected = _c.expected, mock = _c.mock;
        _loop_6(name, input, expected, mock);
    }
});
describe("addLabelToCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "ラベルをカードに登録できる",
            isError: false,
            input: "./src/__tests__/trello_events/addLabelToCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_a = {},
                    _a[Kintone_1.CardApp.labelTable] = {
                        value: [{ value: { LABEL_ID: "5f1e6180d9aed686cc5a1ca5" } }],
                    },
                    _a),
            },
            mock: {
                getRecords: function () {
                    var _a;
                    return Promise.resolve({
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.labelTable] = {
                                    value: [],
                                },
                                _a),
                        ],
                    });
                },
            },
        },
        {
            name: "すでにラベルがあってもラベルをカードに登録できる",
            isError: false,
            input: "./src/__tests__/trello_events/addLabelToCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_b = {},
                    _b[Kintone_1.CardApp.labelTable] = {
                        value: [
                            { id: "2" },
                            { id: "3" },
                            { value: { LABEL_ID: "5f1e6180d9aed686cc5a1ca5" } },
                        ],
                    },
                    _b),
            },
            mock: {
                getRecords: function () {
                    var _a;
                    return Promise.resolve({
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.labelTable] = {
                                    value: [
                                        {
                                            id: 2,
                                            value: { LABEL_ID: "alreadyLabelId1", LABEL_NAME: "red" },
                                        },
                                        {
                                            id: 3,
                                            value: {
                                                LABEL_ID: "alreadyLabelId2",
                                                LABEL_NAME: "blue",
                                            },
                                        },
                                    ],
                                },
                                _a),
                        ],
                    });
                },
            },
        },
        {
            name: "すでに同じラベルがあった場合ラベルをカードに追加しない",
            isError: true,
            input: "./src/__tests__/trello_events/addLabelToCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: {},
            },
            mock: {
                getRecords: function () {
                    var _a;
                    return Promise.resolve({
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.labelTable] = {
                                    value: [
                                        {
                                            id: "1",
                                            value: {
                                                LABEL_ID: { value: "5f1e6180d9aed686cc5a1ca5" },
                                                LABEL_NAME: { value: "yellow" },
                                            },
                                        },
                                        {
                                            id: 2,
                                            value: {
                                                LABEL_ID: { value: "alreadyLabelId1" },
                                                LABEL_NAME: { value: "red" },
                                            },
                                        },
                                        {
                                            id: 3,
                                            value: {
                                                LABEL_ID: { value: "alreadyLabelId2" },
                                                LABEL_NAME: { value: "blue" },
                                            },
                                        },
                                    ],
                                },
                                _a),
                        ],
                    });
                },
            },
        },
    ];
    var _loop_7 = function (name, input, expected, mock, isError) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var throwFunction, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isError) return [3 /*break*/, 2];
                        throwFunction = function () { return __awaiter(void 0, void 0, void 0, function () {
                            return __generator(this, function (_a) {
                                switch (_a.label) {
                                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                                    case 1:
                                        _a.sent();
                                        return [2 /*return*/];
                                }
                            });
                        }); };
                        return [4 /*yield*/, expect(throwFunction).rejects.toThrowError(new Error("Label gsgaga(5f1e6180d9aed686cc5a1ca5) is already exists"))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                    case 2: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 3:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_7 = testcases; _i < testcases_7.length; _i++) {
        var _c = testcases_7[_i], name = _c.name, input = _c.input, expected = _c.expected, mock = _c.mock, isError = _c.isError;
        _loop_7(name, input, expected, mock, isError);
    }
});
describe("removeLabelFromCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "ラベルからカードを削除できる",
            input: "./src/__tests__/trello_events/removeLabelFromCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_a = {},
                    _a[Kintone_1.CardApp.labelTable] = {
                        value: [],
                    },
                    _a),
            },
            mock: {
                getRecords: function () {
                    var _a;
                    return Promise.resolve({
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.labelTable] = {
                                    value: [
                                        {
                                            id: "1",
                                            value: {
                                                LABEL_ID: { value: "5f02821bf1bb5752f63a5ae1" },
                                                LABEL_NAME: { value: "yellow" },
                                            },
                                        },
                                    ],
                                },
                                _a),
                        ],
                    });
                },
            },
        },
        {
            name: "指定したカードのみ削除できる",
            input: "./src/__tests__/trello_events/removeLabelFromCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_b = {},
                    _b[Kintone_1.CardApp.labelTable] = {
                        value: [{ id: "2" }, { id: "3" }],
                    },
                    _b),
            },
            mock: {
                getRecords: function () {
                    var _a;
                    return Promise.resolve({
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.labelTable] = {
                                    value: [
                                        {
                                            id: "1",
                                            value: {
                                                LABEL_ID: { value: "5f02821bf1bb5752f63a5ae1" },
                                                LABEL_NAME: { value: "yellow" },
                                            },
                                        },
                                        {
                                            id: 2,
                                            value: {
                                                LABEL_ID: { value: "alreadyLabelId1" },
                                                LABEL_NAME: { value: "red" },
                                            },
                                        },
                                        {
                                            id: 3,
                                            value: {
                                                LABEL_ID: { value: "alreadyLabelId2" },
                                                LABEL_NAME: { value: "blue" },
                                            },
                                        },
                                    ],
                                },
                                _a),
                        ],
                    });
                },
            },
        },
    ];
    var _loop_8 = function (name, input, expected, mock) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_8 = testcases; _i < testcases_8.length; _i++) {
        var _c = testcases_8[_i], name = _c.name, input = _c.input, expected = _c.expected, mock = _c.mock;
        _loop_8(name, input, expected, mock);
    }
});
describe("addMemberToCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "メンバーをカードに登録できる",
            input: "./src/__tests__/trello_events/addMemberToCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_a = {},
                    _a[Kintone_1.CardApp.member] = { value: [{ code: "aaa" }] },
                    _a),
            },
            mock: {
                getRecords: function (params) {
                    var _a, _b;
                    var returnValue;
                    if (params.fields.includes(Kintone_1.CardApp.member)) {
                        returnValue = {
                            records: [
                                (_a = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _a[Kintone_1.CardApp.member] = { value: [] },
                                    _a),
                            ],
                        };
                    }
                    else {
                        returnValue = {
                            records: [
                                (_b = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _b[Kintone_1.MemberApp.kintoneUser] = {
                                        value: [{ code: "aaa", name: "aaaa" }],
                                    },
                                    _b),
                            ],
                        };
                    }
                    return Promise.resolve(returnValue);
                },
            },
        },
        {
            name: "すでに他のメンバが登録されている状態でメンバを増やしてもすでにいるメンバは消えない",
            input: "./src/__tests__/trello_events/addMemberToCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_b = {},
                    _b[Kintone_1.CardApp.member] = {
                        value: [
                            { code: "other user1" },
                            { code: "other user2" },
                            { code: "user" },
                        ],
                    },
                    _b),
            },
            mock: {
                getRecords: function (params) {
                    var _a, _b;
                    var returnValue;
                    if (params.fields.includes(Kintone_1.CardApp.member)) {
                        returnValue = {
                            records: [
                                (_a = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _a[Kintone_1.CardApp.member] = {
                                        value: [
                                            { code: "other user1", name: "aaaa" },
                                            { code: "other user2", name: "aaaa" },
                                        ],
                                    },
                                    _a),
                            ],
                        };
                    }
                    else {
                        returnValue = {
                            records: [
                                (_b = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _b[Kintone_1.MemberApp.kintoneUser] = {
                                        value: [{ code: "user", name: "aaaa" }],
                                    },
                                    _b),
                            ],
                        };
                    }
                    return Promise.resolve(returnValue);
                },
            },
        },
    ];
    var _loop_9 = function (name, input, expected, mock) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_9 = testcases; _i < testcases_9.length; _i++) {
        var _c = testcases_9[_i], name = _c.name, input = _c.input, expected = _c.expected, mock = _c.mock;
        _loop_9(name, input, expected, mock);
    }
});
describe("removeMemberFromCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "メンバーをカードから削除できる",
            input: "./src/__tests__/trello_events/removeMemberFromCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_a = {},
                    _a[Kintone_1.CardApp.member] = { value: [] },
                    _a),
            },
            mock: {
                getRecords: function (params) {
                    var _a, _b;
                    var returnValue;
                    if (params.fields.includes(Kintone_1.CardApp.member)) {
                        returnValue = {
                            records: [
                                (_a = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _a[Kintone_1.CardApp.member] = {
                                        value: [{ code: "aaa", name: "aaaa" }],
                                    },
                                    _a),
                            ],
                        };
                    }
                    else {
                        returnValue = {
                            records: [
                                (_b = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _b[Kintone_1.MemberApp.kintoneUser] = {
                                        value: [{ code: "aaa", name: "aaaa" }],
                                    },
                                    _b),
                            ],
                        };
                    }
                    return Promise.resolve(returnValue);
                },
            },
        },
        {
            name: "すでに他のメンバが登録されている状態でメンバを消してもすでにいるメンバは消えない",
            input: "./src/__tests__/trello_events/removeMemberFromCard_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: (_b = {},
                    _b[Kintone_1.CardApp.member] = {
                        value: [{ code: "other user1" }, { code: "other user2" }],
                    },
                    _b),
            },
            mock: {
                getRecords: function (params) {
                    var _a, _b;
                    var returnValue;
                    if (params.fields.includes(Kintone_1.CardApp.member)) {
                        returnValue = {
                            records: [
                                (_a = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _a[Kintone_1.CardApp.member] = {
                                        value: [
                                            { code: "other user1", name: "aaaa" },
                                            { code: "other user2", name: "aaaa" },
                                            { code: "user", name: "aaaa" },
                                        ],
                                    },
                                    _a),
                            ],
                        };
                    }
                    else {
                        returnValue = {
                            records: [
                                (_b = {
                                        $id: { value: "5f1590bb8a1a602edd449930" }
                                    },
                                    _b[Kintone_1.MemberApp.kintoneUser] = {
                                        value: [{ code: "user", name: "aaaa" }],
                                    },
                                    _b),
                            ],
                        };
                    }
                    return Promise.resolve(returnValue);
                },
            },
        },
    ];
    var _loop_10 = function (name, input, expected, mock) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_10 = testcases; _i < testcases_10.length; _i++) {
        var _c = testcases_10[_i], name = _c.name, input = _c.input, expected = _c.expected, mock = _c.mock;
        _loop_10(name, input, expected, mock);
    }
});
describe("copyCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "カードを追加できる",
            input: "./src/__tests__/trello_events/copyCard_1.json",
            expected: {
                app: "",
                record: (_a = {},
                    _a[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                    _a[Kintone_1.CardApp.id] = { value: "5f1590bb8a1a602edd449930" },
                    _a[Kintone_1.CardApp.link] = { value: "https://trello.com/c/ceDVYykj" },
                    _a[Kintone_1.CardApp.idList] = { value: "5f1e8b1ed6438e403c6f18fe" },
                    _a),
            },
        },
        {
            name: "listがjsonにない場合でも追加できる",
            input: "./src/__tests__/trello_events/copyCard_2.json",
            expected: {
                app: "",
                record: (_b = {},
                    _b[Kintone_1.CardApp.name] = { value: "これは新しいカードです！！" },
                    _b[Kintone_1.CardApp.id] = { value: "5f1590bb8a1a602edd449930" },
                    _b[Kintone_1.CardApp.link] = { value: "https://trello.com/c/ceDVYykj" },
                    _b),
            },
        },
    ];
    var _loop_11 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_11 = testcases; _i < testcases_11.length; _i++) {
        var _c = testcases_11[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_11(name, input, expected);
    }
});
describe("commentCardのテスト", function () {
    var testcases = [
        {
            name: "カードにコメントを登録できる",
            input: "./src/__tests__/trello_events/commentCard_1.json",
            expected: {
                app: "",
                record: "aaa",
                comment: {
                    text: "korosuke613:Futa Hirakoba (平木場 風太)\n\nコメントだよ",
                },
            },
        },
    ];
    var _loop_12 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_12 = testcases; _i < testcases_12.length; _i++) {
        var _a = testcases_12[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_12(name, input, expected);
    }
});
describe("addAttachmentToCardのテスト", function () {
    var testcases = [
        {
            name: "すでに添付ファイルがあっても追加できる",
            input: "./src/__tests__/trello_events/addAttachmentToCard_image_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: {
                    ATTACHMENT_TABLE: {
                        value: [
                            {
                                id: "user",
                            },
                            {
                                value: {
                                    ATTACHMENT_LINK: "https://trello-attachments.s3.amazonaws.com/5f02821bf3e65f322beb3ea4/5f1e865323566c0f75e0c961/a55cc55c80fb1acaef879692dd13f4b1/%E3%82%B9%E3%82%AF%E3%83%AA%E3%83%BC%E3%83%B3%E3%82%B7%E3%83%A7%E3%83%83%E3%83%88_2020-08-23_14.22.18.png",
                                    ATTACHMENT_NAME: "スクリーンショット 2020-08-23 14.22.18.png",
                                },
                            },
                        ],
                    },
                },
            },
            mock: {
                getRecords: function (params) {
                    var _a;
                    var returnValue = {
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.attachmentTable] = {
                                    value: [{ id: "user", name: "aaaa" }],
                                },
                                _a),
                        ],
                    };
                    return Promise.resolve(returnValue);
                },
            },
        },
        {
            name: "添付ファイルがなくても追加できる",
            input: "./src/__tests__/trello_events/addAttachmentToCard_link_1.json",
            expected: {
                app: "",
                id: "5f1590bb8a1a602edd449930",
                record: {
                    ATTACHMENT_TABLE: {
                        value: [
                            {
                                value: {
                                    ATTACHMENT_LINK: "https://trello.com/b/Sqsia9EM/trello-api%E3%83%86%E3%82%B9%E3%83%88",
                                    ATTACHMENT_NAME: "https://trello.com/b/Sqsia9EM/trello-api%E3%83%86%E3%82%B9%E3%83%88",
                                },
                            },
                        ],
                    },
                },
            },
            mock: {
                getRecords: function (params) {
                    var _a;
                    var returnValue = {
                        records: [
                            (_a = {
                                    $id: { value: "5f1590bb8a1a602edd449930" }
                                },
                                _a[Kintone_1.CardApp.attachmentTable] = {
                                    value: [],
                                },
                                _a),
                        ],
                    };
                    return Promise.resolve(returnValue);
                },
            },
        },
    ];
    var _loop_13 = function (name, input, expected, mock) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, runOperationKintone(input, mock)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_13 = testcases; _i < testcases_13.length; _i++) {
        var _a = testcases_13[_i], name = _a.name, input = _a.input, expected = _a.expected, mock = _a.mock;
        _loop_13(name, input, expected, mock);
    }
});
