import { Action } from "./Trello";
export interface Setting {
    prefixRecordId?: string;
    excludes?: Array<{
        charactersOrLess?: number;
        match?: string;
    }>;
    isAddDoneTime?: boolean;
    doneListName?: string;
}
export declare class SettingGuardian {
    setting: Setting;
    constructor(setting?: Setting);
    getPrefixRecordId(): string;
    isAddDoneTime(listName: string): boolean;
    isSkipEvent(trelloAction: Action): boolean;
}
